import React from 'react';
import type { MRT_Cell, MRT_Column, MRT_ColumnDef, MRT_FilterOption, MRT_Localization, MRT_Row, MRT_TableInstance, MRT_TableState, MaterialReactTableProps } from '..';
export declare const MRT_TableRoot: <TData extends Record<string, any> = {}>(props: Omit<Partial<import("@tanstack/react-table").TableOptions<TData>>, "state" | "data" | "onStateChange" | "initialState" | "getRowId" | "columns" | "defaultColumn" | "globalFilterFn" | "enableRowSelection" | "expandRowsFn"> & {
    columnFilterModeOptions?: (string & MRT_FilterOption)[] | null | undefined;
    columns: MRT_ColumnDef<TData>[];
    data: TData[];
    defaultColumn?: Partial<MRT_ColumnDef<TData>> | undefined;
    defaultDisplayColumn?: Partial<MRT_ColumnDef<TData>> | undefined;
    displayColumnDefOptions?: Partial<{
        "mrt-row-drag": Partial<MRT_ColumnDef<{}>>;
        "mrt-row-actions": Partial<MRT_ColumnDef<{}>>;
        "mrt-row-expand": Partial<MRT_ColumnDef<{}>>;
        "mrt-row-select": Partial<MRT_ColumnDef<{}>>;
        "mrt-row-numbers": Partial<MRT_ColumnDef<{}>>;
    }> | undefined;
    editingMode?: "row" | "cell" | "table" | "modal" | undefined;
    enableBottomToolbar?: boolean | undefined;
    enableClickToCopy?: boolean | undefined;
    enableColumnActions?: boolean | undefined;
    enableColumnDragging?: boolean | undefined;
    enableColumnFilterModes?: boolean | undefined;
    enableColumnOrdering?: boolean | undefined;
    enableColumnVirtualization?: boolean | undefined;
    enableDensityToggle?: boolean | undefined;
    enableEditing?: boolean | undefined;
    enableExpandAll?: boolean | undefined;
    enableFilterMatchHighlighting?: boolean | undefined;
    enableFullScreenToggle?: boolean | undefined;
    enableGlobalFilterModes?: boolean | undefined;
    enableGlobalFilterRankedResults?: boolean | undefined;
    enablePagination?: boolean | undefined;
    enableRowActions?: boolean | undefined;
    enableRowDragging?: boolean | undefined;
    enableRowNumbers?: boolean | undefined;
    enableRowOrdering?: boolean | undefined;
    enableRowSelection?: boolean | ((row: MRT_Row<TData>) => boolean) | undefined;
    enableRowVirtualization?: boolean | undefined;
    enableSelectAll?: boolean | undefined;
    enableStickyFooter?: boolean | undefined;
    enableStickyHeader?: boolean | undefined;
    enableTableFooter?: boolean | undefined;
    enableTableHead?: boolean | undefined;
    enableToolbarInternalActions?: boolean | undefined;
    enableTopToolbar?: boolean | undefined;
    expandRowsFn?: ((dataRow: TData) => TData[]) | undefined;
    getRowId?: ((originalRow: TData, index: number, parentRow: MRT_Row<TData>) => string) | undefined;
    globalFilterFn?: MRT_FilterOption | undefined;
    globalFilterModeOptions?: MRT_FilterOption[] | null | undefined;
    icons?: Partial<import("..").MRT_Icons> | undefined;
    initialState?: Partial<MRT_TableState<TData>> | undefined;
    layoutMode?: "grid" | "semantic" | undefined;
    localization?: Partial<MRT_Localization> | undefined;
    memoMode?: "rows" | "cells" | "table-body" | undefined;
    muiBottomToolbarProps?: import("@mui/material").ToolbarProps<"div", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").ToolbarProps<"div", {}>) | undefined;
    muiExpandAllButtonProps?: import("@mui/material").IconButtonProps<"button", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").IconButtonProps<"button", {}>) | undefined;
    muiExpandButtonProps?: import("@mui/material").IconButtonProps<"button", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        row: MRT_Row<TData>;
    }) => import("@mui/material").IconButtonProps<"button", {}>) | undefined;
    muiLinearProgressProps?: import("@mui/material").LinearProgressProps | ((props: {
        isTopToolbar: boolean;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").LinearProgressProps) | undefined;
    muiSearchTextFieldProps?: import("@mui/material").TextFieldProps | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TextFieldProps) | undefined;
    muiSelectAllCheckboxProps?: import("@mui/material").CheckboxProps | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").CheckboxProps) | undefined;
    muiSelectCheckboxProps?: import("@mui/material").CheckboxProps | import("@mui/material").RadioProps | ((props: {
        table: MRT_TableInstance<TData>;
        row: MRT_Row<TData>;
    }) => import("@mui/material").CheckboxProps | import("@mui/material").RadioProps) | undefined;
    muiTableBodyCellCopyButtonProps?: import("@mui/material").ButtonProps<"button", {}> | ((props: {
        cell: MRT_Cell<TData>;
        column: MRT_Column<TData>;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").ButtonProps<"button", {}>) | undefined;
    muiTableBodyCellEditTextFieldProps?: import("@mui/material").TextFieldProps | ((props: {
        cell: MRT_Cell<TData>;
        column: MRT_Column<TData>;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TextFieldProps) | undefined;
    muiTableBodyCellProps?: import("@mui/material").TableCellProps | ((props: {
        cell: MRT_Cell<TData>;
        column: MRT_Column<TData>;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableCellProps) | undefined;
    muiTableBodyCellSkeletonProps?: import("@mui/material").SkeletonProps<"span", {}> | ((props: {
        cell: MRT_Cell<TData>;
        column: MRT_Column<TData>;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").SkeletonProps<"span", {}>) | undefined;
    muiTableBodyProps?: import("@mui/material").TableBodyProps<"tbody", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableBodyProps<"tbody", {}>) | undefined;
    muiTableBodyRowDragHandleProps?: import("@mui/material").IconButtonProps<"button", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        row: MRT_Row<TData>;
    }) => import("@mui/material").IconButtonProps<"button", {}>) | undefined;
    muiTableBodyRowProps?: import("@mui/material").TableRowProps<"tr", {}> | ((props: {
        isDetailPanel?: boolean | undefined;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableRowProps<"tr", {}>) | undefined;
    muiTableContainerProps?: import("@mui/material").TableContainerProps<"div", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableContainerProps<"div", {}>) | undefined;
    muiTableDetailPanelProps?: import("@mui/material").TableCellProps | ((props: {
        table: MRT_TableInstance<TData>;
        row: MRT_Row<TData>;
    }) => import("@mui/material").TableCellProps) | undefined;
    muiTableFooterCellProps?: import("@mui/material").TableCellProps | ((props: {
        table: MRT_TableInstance<TData>;
        column: MRT_Column<TData>;
    }) => import("@mui/material").TableCellProps) | undefined;
    muiTableFooterProps?: import("@mui/material").TableFooterProps<"tfoot", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableFooterProps<"tfoot", {}>) | undefined;
    muiTableFooterRowProps?: import("@mui/material").TableRowProps<"tr", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        footerGroup: import("..").MRT_HeaderGroup<TData>;
    }) => import("@mui/material").TableRowProps<"tr", {}>) | undefined;
    muiTableHeadCellColumnActionsButtonProps?: import("@mui/material").IconButtonProps<"button", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        column: MRT_Column<TData>;
    }) => import("@mui/material").IconButtonProps<"button", {}>) | undefined;
    muiTableHeadCellDragHandleProps?: import("@mui/material").IconButtonProps<"button", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        column: MRT_Column<TData>;
    }) => import("@mui/material").IconButtonProps<"button", {}>) | undefined;
    muiTableHeadCellFilterCheckboxProps?: import("@mui/material").CheckboxProps | ((props: {
        column: MRT_Column<TData>;
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").CheckboxProps) | undefined;
    muiTableHeadCellFilterTextFieldProps?: import("@mui/material").TextFieldProps | ((props: {
        table: MRT_TableInstance<TData>;
        column: MRT_Column<TData>;
        rangeFilterIndex?: number | undefined;
    }) => import("@mui/material").TextFieldProps) | undefined;
    muiTableHeadCellProps?: import("@mui/material").TableCellProps | ((props: {
        table: MRT_TableInstance<TData>;
        column: MRT_Column<TData>;
    }) => import("@mui/material").TableCellProps) | undefined;
    muiTableHeadProps?: import("@mui/material").TableHeadProps<"thead", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableHeadProps<"thead", {}>) | undefined;
    muiTableHeadRowProps?: import("@mui/material").TableRowProps<"tr", {}> | ((props: {
        table: MRT_TableInstance<TData>;
        headerGroup: import("..").MRT_HeaderGroup<TData>;
    }) => import("@mui/material").TableRowProps<"tr", {}>) | undefined;
    muiTablePaginationProps?: Partial<import("@mui/material").TablePaginationProps<React.JSXElementConstructor<import("@mui/material").TablePaginationBaseProps>, {}>> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => Partial<import("@mui/material").TablePaginationProps<React.JSXElementConstructor<import("@mui/material").TablePaginationBaseProps>, {}>>) | undefined;
    muiTablePaperProps?: import("@mui/material").PaperProps<"div", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").PaperProps<"div", {}>) | undefined;
    muiTableProps?: import("@mui/material").TableProps<"table", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").TableProps<"table", {}>) | undefined;
    muiToolbarAlertBannerChipProps?: import("@mui/material").ChipProps<"div", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").ChipProps<"div", {}>) | undefined;
    muiToolbarAlertBannerProps?: import("@mui/material").AlertProps | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").AlertProps) | undefined;
    muiTopToolbarProps?: import("@mui/material").ToolbarProps<"div", {}> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => import("@mui/material").ToolbarProps<"div", {}>) | undefined;
    onDensityChange?: import("@tanstack/react-table").OnChangeFn<import("..").DensityState> | undefined;
    onDraggingColumnChange?: import("@tanstack/react-table").OnChangeFn<MRT_Column<TData> | null> | undefined;
    onDraggingRowChange?: import("@tanstack/react-table").OnChangeFn<MRT_Row<TData> | null> | undefined;
    onEditingCellChange?: import("@tanstack/react-table").OnChangeFn<MRT_Cell<TData> | null> | undefined;
    onEditingRowCancel?: ((props: {
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => void) | undefined;
    onEditingRowSave?: ((props: {
        exitEditingMode: () => void;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
        values: Record<(string & Record<never, never>) | (string & import("@tanstack/react-table").DeepKeys<TData>), any>;
    }) => void | Promise<void>) | undefined;
    onEditingRowChange?: import("@tanstack/react-table").OnChangeFn<MRT_Row<TData> | null> | undefined;
    onColumnFilterFnsChange?: import("@tanstack/react-table").OnChangeFn<{
        [key: string]: MRT_FilterOption;
    }> | undefined;
    onGlobalFilterFnChange?: import("@tanstack/react-table").OnChangeFn<MRT_FilterOption> | undefined;
    onHoveredColumnChange?: import("@tanstack/react-table").OnChangeFn<MRT_Column<TData> | null> | undefined;
    onHoveredRowChange?: import("@tanstack/react-table").OnChangeFn<MRT_Row<TData> | null> | undefined;
    onIsFullScreenChange?: import("@tanstack/react-table").OnChangeFn<boolean> | undefined;
    onShowAlertBannerChange?: import("@tanstack/react-table").OnChangeFn<boolean> | undefined;
    onShowFiltersChange?: import("@tanstack/react-table").OnChangeFn<boolean> | undefined;
    onShowGlobalFilterChange?: import("@tanstack/react-table").OnChangeFn<boolean> | undefined;
    onShowToolbarDropZoneChange?: import("@tanstack/react-table").OnChangeFn<boolean> | undefined;
    positionActionsColumn?: "first" | "last" | undefined;
    positionExpandColumn?: "first" | "last" | undefined;
    positionGlobalFilter?: "left" | "right" | "none" | undefined;
    positionPagination?: "bottom" | "top" | "none" | "both" | undefined;
    positionToolbarAlertBanner?: "bottom" | "top" | "none" | undefined;
    positionToolbarDropZone?: "bottom" | "top" | "none" | "both" | undefined;
    renderBottomToolbar?: React.ReactNode | ((props: {
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode);
    renderBottomToolbarCustomActions?: ((props: {
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode) | undefined;
    renderColumnActionsMenuItems?: ((props: {
        column: MRT_Column<TData>;
        closeMenu: () => void;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode[]) | undefined;
    renderColumnFilterModeMenuItems?: ((props: {
        column: MRT_Column<TData>;
        internalFilterOptions: import("..").MRT_InternalFilterOption[];
        onSelectFilterMode: (filterMode: MRT_FilterOption) => void;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode[]) | undefined;
    renderDetailPanel?: ((props: {
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode) | undefined;
    renderGlobalFilterModeMenuItems?: ((props: {
        internalFilterOptions: import("..").MRT_InternalFilterOption[];
        onSelectFilterMode: (filterMode: MRT_FilterOption) => void;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode[]) | undefined;
    renderRowActionMenuItems?: ((props: {
        closeMenu: () => void;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode[]) | undefined;
    renderRowActions?: ((props: {
        cell: MRT_Cell<TData>;
        row: MRT_Row<TData>;
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode) | undefined;
    renderToolbarInternalActions?: ((props: {
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode) | undefined;
    renderTopToolbar?: React.ReactNode | ((props: {
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode);
    renderTopToolbarCustomActions?: ((props: {
        table: MRT_TableInstance<TData>;
    }) => React.ReactNode) | undefined;
    rowCount?: number | undefined;
    rowNumberMode?: "original" | "static" | undefined;
    selectAllMode?: "all" | "page" | undefined;
    state?: Partial<MRT_TableState<TData>> | undefined;
    columnVirtualizerInstanceRef?: React.MutableRefObject<import("@tanstack/react-virtual").Virtualizer<HTMLDivElement, HTMLTableCellElement> | null> | undefined;
    columnVirtualizerProps?: Partial<import("@tanstack/react-virtual").VirtualizerOptions<HTMLDivElement, HTMLTableCellElement>> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => Partial<import("@tanstack/react-virtual").VirtualizerOptions<HTMLDivElement, HTMLTableCellElement>>) | undefined;
    rowVirtualizerInstanceRef?: React.MutableRefObject<import("@tanstack/react-virtual").Virtualizer<HTMLDivElement, HTMLTableRowElement> | null> | undefined;
    rowVirtualizerProps?: Partial<import("@tanstack/react-virtual").VirtualizerOptions<HTMLDivElement, HTMLTableRowElement>> | ((props: {
        table: MRT_TableInstance<TData>;
    }) => Partial<import("@tanstack/react-virtual").VirtualizerOptions<HTMLDivElement, HTMLTableRowElement>>) | undefined;
    tableInstanceRef?: React.MutableRefObject<MRT_TableInstance<TData> | null> | undefined;
    virtualizerInstanceRef?: any;
    virtualizerProps?: any;
} & {
    localization: MRT_Localization;
}) => JSX.Element;
